#include "AngleUsing.h"

#include "Angle.h"
#include <math.h>

namespace Passer {
typedef AngleUsing<signed long> Angle32;

template <> Angle32::AngleUsing(float angle) {
  if (!isfinite(angle)) {
    value = 0;
    return;
  }

  // map float [-180..180) to integer [-2147483648..2147483647]
  this->value = (signed long)((angle / 360.0F) * 4294967295.0F);
}

template <> float Angle32::ToFloat() const {
  float f = ((this->value * 180) / 2147483648.0F);
  return f;
}

} // namespace Passer
using namespace Passer;